--- ./gdb/configure.ac.orig	2013-08-14 14:52:59 +0600
+++ ./gdb/configure.ac	2013-08-14 14:54:19 +0600
@@ -1111,7 +1111,7 @@ AC_CHECK_FUNCS([canonicalize_file_name r
 		sbrk setpgid setpgrp setsid \
 		sigaction sigprocmask sigsetmask socketpair syscall \
 		ttrace wborder wresize setlocale iconvlist libiconvlist btowc \
-		setrlimit getrlimit posix_madvise waitpid lstat])
+		setrlimit getrlimit posix_madvise waitpid lstat ptrace64])
 AM_LANGINFO_CODESET
 
 # Check the return and argument types of ptrace.  No canned test for
--- ./gdb/config.in.orig	2013-08-14 14:55:44 +0600
+++ ./gdb/config.in	2013-08-14 14:55:59 +0600
@@ -321,6 +321,9 @@
 /* Define if <sys/procfs.h> has pstatus_t. */
 #undef HAVE_PSTATUS_T
 
+/* Define to 1 if you have the `ptrace64' function. */
+#undef HAVE_PTRACE64
+
 /* Define if sys/ptrace.h defines the PTRACE_GETFPXREGS request. */
 #undef HAVE_PTRACE_GETFPXREGS
 
--- ./gdb/configure.orig	2013-08-14 14:55:02 +0600
+++ ./gdb/configure	2013-08-14 14:55:14 +0600
@@ -10115,7 +10115,7 @@ for ac_func in canonicalize_file_name re
 		sbrk setpgid setpgrp setsid \
 		sigaction sigprocmask sigsetmask socketpair syscall \
 		ttrace wborder wresize setlocale iconvlist libiconvlist btowc \
-		setrlimit getrlimit posix_madvise waitpid lstat
+		setrlimit getrlimit posix_madvise waitpid lstat ptrace64
 do :
   as_ac_var=`$as_echo "ac_cv_func_$ac_func" | $as_tr_sh`
 ac_fn_c_check_func "$LINENO" "$ac_func" "$as_ac_var"
--- ./gdb/gdb_ptrace.h.orig	2013-08-14 14:46:56 +0600
+++ ./gdb/gdb_ptrace.h	2013-08-14 14:48:02 +0600
@@ -135,7 +135,15 @@ extern PTRACE_TYPE_RET ptrace();
    zero.  */
 
 #ifdef PTRACE_TYPE_ARG5
-# define ptrace(request, pid, addr, data) ptrace (request, pid, addr, data, 0)
+# ifdef HAVE_PTRACE64
+#  define ptrace(request, pid, addr, data) \
+          ptrace64 (request, pid, addr, data, 0)
+#  undef PTRACE_TYPE_ARG3
+#  define PTRACE_TYPE_ARG3 long long
+# else
+#  define ptrace(request, pid, addr, data) \
+          ptrace (request, pid, addr, data, 0)
+# endif
 #endif
 
 #endif /* gdb_ptrace.h */
--- ./gdb/rs6000-nat.c.orig	2013-08-14 14:49:11 +0600
+++ ./gdb/rs6000-nat.c	2013-08-14 14:51:51 +0600
@@ -66,7 +66,7 @@
 /* In 32-bit compilation mode (which is the only mode from which ptrace()
    works on 4.3), __ld_info32 is #defined as equivalent to ld_info.  */
 
-#ifdef __ld_info32
+#if defined (__ld_info32) || defined (__ld_info64)
 # define ARCH3264
 #endif
 
@@ -181,7 +181,11 @@ regmap (struct gdbarch *gdbarch, int reg
 static int
 rs6000_ptrace32 (int req, int id, int *addr, int data, int *buf)
 {
-  int ret = ptrace (req, id, (int *)addr, data, buf);
+  #ifdef HAVE_PTRACE64
+   int ret = ptrace64 (req, id, (long long) addr, data, buf);
+  #else
+   int ret = ptrace (req, id, (int *)addr, data, buf);
+  #endif
 #if 0
   printf ("rs6000_ptrace32 (%d, %d, 0x%x, %08x, 0x%x) = 0x%x\n",
 	  req, id, (unsigned int)addr, data, (unsigned int)buf, ret);
@@ -195,7 +199,11 @@ static int
 rs6000_ptrace64 (int req, int id, long long addr, int data, void *buf)
 {
 #ifdef ARCH3264
-  int ret = ptracex (req, id, addr, data, buf);
+  #ifdef HAVE_PTRACE64
+   int ret = ptrace64 (req, id, addr, data, buf);
+  #else
+   int ret = ptracex (req, id, addr, data, buf);
+  #endif
 #else
   int ret = 0;
 #endif
